// -*- C++ -*-
// Copyright (C) 2000 Red Hat, Inc.

/*
  Inti is a C++ development platform based on glib, GTK+, and the
  Standard Template Library. This source file is machine-generated
  by a script; do not edit it directly.

  This file is distributed under the GNU Library General Public License.
*/
#include "connection.h"

Inti::Private::ConnectionImpl::ConnectionImpl ()
  : ref_count_(1), disconnected_(false)
{
}

Inti::Private::ConnectionImpl::~ConnectionImpl ()
{

}

void
Inti::Private::ConnectionImpl::unref ()
{
  ref_count_ -= 1;
  if (ref_count_ == 0)
    delete this;
}

///////////////////////////


Inti::Connection::Connection (Private::ConnectionImpl * impl)
  : impl_(impl)
{
  impl_->ref ();
}

Inti::Connection::Connection (const Connection & src)
  : impl_(src.impl_)
{
  if (impl_)
    impl_->ref ();
}

Inti::Connection::~Connection ()
{
  if (impl_)
    impl_->unref ();
}

Inti::Connection&
Inti::Connection::operator=(const Connection& src)
{
  if (src.impl_)
    src.impl_->ref ();
  if (impl_)
    impl_->unref ();
  impl_ = src.impl_;
  return *this;
}
    
void
Inti::Connection::disconnect ()
{
  if (impl_)
    {
      impl_->disconnect ();
      impl_->unref ();
      impl_ = 0;
    }
}

void
Inti::Connection::block ()
{
  if (impl_)
    impl_->block ();
}

void
Inti::Connection::unblock ()
{
  if (impl_)
    impl_->unblock ();
}

/////////// Everything below here is machine-generated
