// -*- C++ -*-
// Copyright (C) 2000 Red Hat, Inc.
#ifndef _INTI_GTK_BOX_CLASS_H_
#define _INTI_GTK_BOX_CLASS_H_

/*
  Inti is a C++ development platform based on glib, GTK+, and the
  Standard Template Library. This header file is machine-generated
  by a script; do not edit it directly.

  This file is distributed under the GNU Library General Public License.
*/
/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */


/*$ doc header
  $short The #Inti::Gtk::Private::BoxClass class, which is private and internal.
  $*/

#include <gtk/gtkhbox.h>
#include <gtk/gtkvbox.h>

namespace Inti
{
  class Object;
  
  namespace Gtk
  {
    class Widget;
    class Box;
    class HBox;
    class VBox;
    
    namespace Private
    {      

      class BoxClass
      {
      public:
        static GType type ()
        {
          return gtk_box_get_type ();
        }
        static GType proxy_type ();

        static Inti::Object * get_wrapper (GObject * obj);

        static GObject * make_proxy ()
        {
          return (GObject*) g_type_create_instance (proxy_type ());
        }
        static GObjectClass * original_class ();
        static void class_init (GtkBoxClass * klass);
      private:
        static GType type_;
        static GtkBoxClass * original_class_;
        // This class can't be instantiated.
        friend class LookMrCompilerICanCallThesePrivateConstructors;
        BoxClass (const BoxClass &);
        BoxClass & operator=(const BoxClass & );
        BoxClass ();
      }; // class BoxClass
      class HBoxClass
      {
      public:
        static GType type ()
        {
          return gtk_hbox_get_type ();
        }
        static GType proxy_type ();

        static Inti::Object * get_wrapper (GObject * obj);

        static GObject * make_proxy ()
        {
          return (GObject*) g_type_create_instance (proxy_type ());
        }
        static GObjectClass * original_class ();
        static void class_init (GtkHBoxClass * klass);
      private:
        static GType type_;
        static GtkHBoxClass * original_class_;
        // This class can't be instantiated.
        friend class LookMrCompilerICanCallThesePrivateConstructors;
        HBoxClass (const HBoxClass &);
        HBoxClass & operator=(const HBoxClass & );
        HBoxClass ();
      }; // class HBoxClass
      class VBoxClass
      {
      public:
        static GType type ()
        {
          return gtk_vbox_get_type ();
        }
        static GType proxy_type ();

        static Inti::Object * get_wrapper (GObject * obj);

        static GObject * make_proxy ()
        {
          return (GObject*) g_type_create_instance (proxy_type ());
        }
        static GObjectClass * original_class ();
        static void class_init (GtkVBoxClass * klass);
      private:
        static GType type_;
        static GtkVBoxClass * original_class_;
        // This class can't be instantiated.
        friend class LookMrCompilerICanCallThesePrivateConstructors;
        VBoxClass (const VBoxClass &);
        VBoxClass & operator=(const VBoxClass & );
        VBoxClass ();
      }; // class VBoxClass
      
    }; //namespace Private

  }; // namespace Gtk

}; // namespace Inti

#endif // _INTI_GTK_BOX_CLASS_H_
