// -*- C++ -*-
// Copyright (C) 2000 Red Hat, Inc.
#ifndef _INTI_GTK_PANED_CLASS_H_
#define _INTI_GTK_PANED_CLASS_H_

/*
  Inti is a C++ development platform based on glib, GTK+, and the
  Standard Template Library. This header file is machine-generated
  by a script; do not edit it directly.

  This file is distributed under the GNU Library General Public License.
*/
/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */


/*$ doc header
  $short The #Inti::Gtk::Private::PanedClass class, which is private and internal.
  $*/

#include <gtk/gtkhpaned.h>
#include <gtk/gtkvpaned.h>

namespace Inti
{
  class Object;
  
  namespace Gtk
  {
    class Widget;
    class Paned;
    class HPaned;
    class VPaned;
    
    namespace Private
    {      

      class PanedClass
      {
      public:
        static GType type ()
        {
          return gtk_paned_get_type ();
        }
        static GType proxy_type ();

        static Inti::Object * get_wrapper (GObject * obj);

        static GObject * make_proxy ()
        {
          return (GObject*) g_type_create_instance (proxy_type ());
        }
        static GObjectClass * original_class ();
        static void class_init (GtkPanedClass * klass);
      private:
        static GType type_;
        static GtkPanedClass * original_class_;
        // This class can't be instantiated.
        friend class LookMrCompilerICanCallThesePrivateConstructors;
        PanedClass (const PanedClass &);
        PanedClass & operator=(const PanedClass & );
        PanedClass ();
      }; // class PanedClass
      class HPanedClass
      {
      public:
        static GType type ()
        {
          return gtk_hpaned_get_type ();
        }
        static GType proxy_type ();

        static Inti::Object * get_wrapper (GObject * obj);

        static GObject * make_proxy ()
        {
          return (GObject*) g_type_create_instance (proxy_type ());
        }
        static GObjectClass * original_class ();
        static void class_init (GtkHPanedClass * klass);
      private:
        static GType type_;
        static GtkHPanedClass * original_class_;
        // This class can't be instantiated.
        friend class LookMrCompilerICanCallThesePrivateConstructors;
        HPanedClass (const HPanedClass &);
        HPanedClass & operator=(const HPanedClass & );
        HPanedClass ();
      }; // class HPanedClass
      class VPanedClass
      {
      public:
        static GType type ()
        {
          return gtk_vpaned_get_type ();
        }
        static GType proxy_type ();

        static Inti::Object * get_wrapper (GObject * obj);

        static GObject * make_proxy ()
        {
          return (GObject*) g_type_create_instance (proxy_type ());
        }
        static GObjectClass * original_class ();
        static void class_init (GtkVPanedClass * klass);
      private:
        static GType type_;
        static GtkVPanedClass * original_class_;
        // This class can't be instantiated.
        friend class LookMrCompilerICanCallThesePrivateConstructors;
        VPanedClass (const VPanedClass &);
        VPanedClass & operator=(const VPanedClass & );
        VPanedClass ();
      }; // class VPanedClass
      
    }; //namespace Private

  }; // namespace Gtk

}; // namespace Inti

#endif // _INTI_GTK_PANED_CLASS_H_
