// -*- C++ -*-
// Copyright (C) 2000 Red Hat, Inc.

/*
  Inti is a C++ development platform based on glib, GTK+, and the
  Standard Template Library. This source file is machine-generated
  by a script; do not edit it directly.

  This file is distributed under the GNU Library General Public License.
*/
#include "radiobutton.h"
#include "radiobutton-class.h"
#include <inti/private-util.h>
#include "marshal.h"
#include "label.h"

Inti::Gtk::RadioButton::RadioButton ()
  : CheckButton ((GtkCheckButton*)Private::RadioButtonClass::make_proxy(),
                 (GtkCheckButtonClass*)Private::RadioButtonClass::original_class())
{
  
}

Inti::Gtk::RadioButton::RadioButton (const ustring & text)
  : CheckButton ((GtkCheckButton*)Private::RadioButtonClass::make_proxy(),
                 (GtkCheckButtonClass*)Private::RadioButtonClass::original_class())
{
  Label * l = new Label (text);
  l->show ();
  add (l);
}

Inti::Gtk::RadioButton::RadioButton (const char * text)
  : CheckButton ((GtkCheckButton*)Private::RadioButtonClass::make_proxy(),
                 (GtkCheckButtonClass*)Private::RadioButtonClass::original_class())
{
  Label * l = new Label (text);
  l->show ();
  add (l);
}

Inti::Gtk::RadioButton::RadioButton (Group group_)
  : CheckButton ((GtkCheckButton*)Private::RadioButtonClass::make_proxy(),
                 (GtkCheckButtonClass*)Private::RadioButtonClass::original_class())
{
  set_group (group_);
}

Inti::Gtk::RadioButton::RadioButton (Group group_, const ustring & text)
  : CheckButton ((GtkCheckButton*)Private::RadioButtonClass::make_proxy(),
                 (GtkCheckButtonClass*)Private::RadioButtonClass::original_class())
{
  set_group (group_);
  
  Label * l = new Label (text);
  l->show ();
  add (l);
}

Inti::Gtk::RadioButton::RadioButton (Group group_, const char * text)
  : CheckButton ((GtkCheckButton*)Private::RadioButtonClass::make_proxy(),
                 (GtkCheckButtonClass*)Private::RadioButtonClass::original_class())
{
  set_group (group_);
  
  Label * l = new Label (text);
  l->show ();
  add (l);
}

Inti::Gtk::RadioButton::RadioButton (GtkRadioButton *obj,
                                        GtkRadioButtonClass *orig)
  : CheckButton ((GtkCheckButton*)obj,
                 (GtkCheckButtonClass*)orig)
{
  
}

Inti::Gtk::RadioButton::~RadioButton ()
{

}

Inti::Gtk::RadioButton::Group::Group (GSList *list)
  : list_(list)
{

}

Inti::Gtk::RadioButton *
Inti::Gtk::RadioButton::Group::get_active ()
{
  GSList *iter = list_;
  while (iter != NULL)
    {
      if (GTK_TOGGLE_BUTTON (iter->data)->active)
        return dynamic_cast<RadioButton*>(Object::wrap ((GObject*)iter->data));
      
      iter = g_slist_next (iter);
    }

  return 0;
}

const Inti::Gtk::RadioButton *
Inti::Gtk::RadioButton::Group::get_active () const
{
  GSList *iter = list_;
  while (iter != NULL)
    {
      if (GTK_TOGGLE_BUTTON (iter->data)->active)
        return dynamic_cast<RadioButton*>(Object::wrap ((GObject*)iter->data));
      
      iter = g_slist_next (iter);
    }

  return 0;
}

Inti::Gtk::RadioButton::Group
Inti::Gtk::RadioButton::group () const
{
  return Group (gtk_radio_button_group (gtk_radio_button ()));
}

void
Inti::Gtk::RadioButton::set_group (Group group_)
{
  gtk_radio_button_set_group (gtk_radio_button (),
                              group_.list_);
}

/////////// Everything below here is machine-generated
