// -*- C++ -*-
// Copyright (C) 2000 Red Hat, Inc.

/*
  Inti is a C++ development platform based on glib, GTK+, and the
  Standard Template Library. This source file is machine-generated
  by a script; do not edit it directly.

  This file is distributed under the GNU Library General Public License.
*/
#include "radiomenuitem.h"
#include "radiomenuitem-class.h"
#include "label.h"
#include <inti/private-util.h>

Inti::Gtk::RadioMenuItem::RadioMenuItem ()
  : CheckMenuItem ((GtkCheckMenuItem*)Private::RadioMenuItemClass::make_proxy (),
                   (GtkCheckMenuItemClass*) Private::RadioMenuItemClass::original_class ())
{

}

Inti::Gtk::RadioMenuItem::RadioMenuItem (const ustring & text)
  : CheckMenuItem ((GtkCheckMenuItem*)Private::RadioMenuItemClass::make_proxy (),
                   (GtkCheckMenuItemClass*) Private::RadioMenuItemClass::original_class ())
{
  Label * label = new Label (text);
  label->show ();
  add (label);
}


Inti::Gtk::RadioMenuItem::RadioMenuItem (Group groupx, const ustring & text)
  : CheckMenuItem ((GtkCheckMenuItem*)Private::RadioMenuItemClass::make_proxy (),
                   (GtkCheckMenuItemClass*) Private::RadioMenuItemClass::original_class ())
{
  set_group (groupx);
  
  Label * label = new Label (text);
  label->show ();
  add (label);
}


Inti::Gtk::RadioMenuItem::RadioMenuItem (Group groupx)
  : CheckMenuItem ((GtkCheckMenuItem*)Private::RadioMenuItemClass::make_proxy (),
                   (GtkCheckMenuItemClass*) Private::RadioMenuItemClass::original_class ())
{
  set_group (groupx);
}


Inti::Gtk::RadioMenuItem::RadioMenuItem (GtkRadioMenuItem *obj, GtkRadioMenuItemClass * orig)
  : CheckMenuItem ((GtkCheckMenuItem*)obj,
                   (GtkCheckMenuItemClass*)orig)
{
  
}

Inti::Gtk::RadioMenuItem::~RadioMenuItem ()
{

}


Inti::Gtk::RadioMenuItem::Group::Group (GSList *list)
  : list_(list)
{

}


Inti::Gtk::RadioMenuItem *
Inti::Gtk::RadioMenuItem::Group::get_active ()
{
  GSList *iter = list_;
  while (iter != NULL)
    {
      if (GTK_CHECK_MENU_ITEM (iter->data)->active)
        return dynamic_cast<RadioMenuItem*>(Object::wrap ((GObject*)iter->data));
      
      iter = g_slist_next (iter);
    }

  return 0;
}

const Inti::Gtk::RadioMenuItem *
Inti::Gtk::RadioMenuItem::Group::get_active () const
{
  GSList *iter = list_;
  while (iter != NULL)
    {
      if (GTK_CHECK_MENU_ITEM (iter->data)->active)
        return dynamic_cast<RadioMenuItem*>(Object::wrap ((GObject*)iter->data));
      
      iter = g_slist_next (iter);
    }

  return 0;
}

Inti::Gtk::RadioMenuItem::Group
Inti::Gtk::RadioMenuItem::group () const
{
  return Group (gtk_radio_menu_item_group (gtk_radio_menu_item ()));
}

void
Inti::Gtk::RadioMenuItem::set_group (Group groupx)
{
  gtk_radio_menu_item_set_group (gtk_radio_menu_item (),
                                 groupx.list_);
}

/////////// Everything below here is machine-generated
