// -*- C++ -*-
// Copyright (C) 2000 Red Hat, Inc.
#ifndef _INTI_GTK_SCALE_CLASS_H_
#define _INTI_GTK_SCALE_CLASS_H_

/*
  Inti is a C++ development platform based on glib, GTK+, and the
  Standard Template Library. This header file is machine-generated
  by a script; do not edit it directly.

  This file is distributed under the GNU Library General Public License.
*/
/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */


/*$ doc header
  $short The #Inti::Gtk::Private::ScaleClass class, which is private and internal.
  $*/

#include <gtk/gtkhscale.h>
#include <gtk/gtkvscale.h>

namespace Inti
{
  class Object;
  
  namespace Gtk
  {
    class Range;
    class Scale;
    class HScale;
    class VScale;
    
    namespace Private
    {      

      class ScaleClass
      {
      public:
        static GType type ()
        {
          return gtk_scale_get_type ();
        }
        static GType proxy_type ();

        static Inti::Object * get_wrapper (GObject * obj);

        static GObject * make_proxy ()
        {
          return (GObject*) g_type_create_instance (proxy_type ());
        }
        static GObjectClass * original_class ();
        static void class_init (GtkScaleClass * klass);
      private:
        static GType type_;
        static GtkScaleClass * original_class_;
        // This class can't be instantiated.
        friend class LookMrCompilerICanCallThesePrivateConstructors;
        ScaleClass (const ScaleClass &);
        ScaleClass & operator=(const ScaleClass & );
        ScaleClass ();
      }; // class ScaleClass
      class HScaleClass
      {
      public:
        static GType type ()
        {
          return gtk_hscale_get_type ();
        }
        static GType proxy_type ();

        static Inti::Object * get_wrapper (GObject * obj);

        static GObject * make_proxy ()
        {
          return (GObject*) g_type_create_instance (proxy_type ());
        }
        static GObjectClass * original_class ();
        static void class_init (GtkHScaleClass * klass);
      private:
        static GType type_;
        static GtkHScaleClass * original_class_;
        // This class can't be instantiated.
        friend class LookMrCompilerICanCallThesePrivateConstructors;
        HScaleClass (const HScaleClass &);
        HScaleClass & operator=(const HScaleClass & );
        HScaleClass ();
      }; // class HScaleClass
      class VScaleClass
      {
      public:
        static GType type ()
        {
          return gtk_vscale_get_type ();
        }
        static GType proxy_type ();

        static Inti::Object * get_wrapper (GObject * obj);

        static GObject * make_proxy ()
        {
          return (GObject*) g_type_create_instance (proxy_type ());
        }
        static GObjectClass * original_class ();
        static void class_init (GtkVScaleClass * klass);
      private:
        static GType type_;
        static GtkVScaleClass * original_class_;
        // This class can't be instantiated.
        friend class LookMrCompilerICanCallThesePrivateConstructors;
        VScaleClass (const VScaleClass &);
        VScaleClass & operator=(const VScaleClass & );
        VScaleClass ();
      }; // class VScaleClass
      
    }; //namespace Private

  }; // namespace Gtk

}; // namespace Inti

#endif // _INTI_GTK_SCALE_CLASS_H_
