// -*- C++ -*-
// Copyright (C) 2000 Red Hat, Inc.
#ifndef _INTI_GTK_SEPARATOR_CLASS_H_
#define _INTI_GTK_SEPARATOR_CLASS_H_

/*
  Inti is a C++ development platform based on glib, GTK+, and the
  Standard Template Library. This header file is machine-generated
  by a script; do not edit it directly.

  This file is distributed under the GNU Library General Public License.
*/
/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */


/*$ doc header
  $short The #Inti::Gtk::Private::SeparatorClass class, which is private and internal.
  $*/

#include <gtk/gtkhseparator.h>
#include <gtk/gtkvseparator.h>

namespace Inti
{
  class Object;
  
  namespace Gtk
  {
    class Widget;
    class Separator;
    
    namespace Private
    {      

      class SeparatorClass
      {
      public:
        static GType type ()
        {
          return gtk_separator_get_type ();
        }
        static GType proxy_type ();

        static Inti::Object * get_wrapper (GObject * obj);

        static GObject * make_proxy ()
        {
          return (GObject*) g_type_create_instance (proxy_type ());
        }
        static GObjectClass * original_class ();
        static void class_init (GtkSeparatorClass * klass);
      private:
        static GType type_;
        static GtkSeparatorClass * original_class_;
        // This class can't be instantiated.
        friend class LookMrCompilerICanCallThesePrivateConstructors;
        SeparatorClass (const SeparatorClass &);
        SeparatorClass & operator=(const SeparatorClass & );
        SeparatorClass ();
      }; // class SeparatorClass
      class HSeparatorClass
      {
      public:
        static GType type ()
        {
          return gtk_hseparator_get_type ();
        }
        static GType proxy_type ();

        static Inti::Object * get_wrapper (GObject * obj);

        static GObject * make_proxy ()
        {
          return (GObject*) g_type_create_instance (proxy_type ());
        }
        static GObjectClass * original_class ();
        static void class_init (GtkHSeparatorClass * klass);
      private:
        static GType type_;
        static GtkHSeparatorClass * original_class_;
        // This class can't be instantiated.
        friend class LookMrCompilerICanCallThesePrivateConstructors;
        HSeparatorClass (const HSeparatorClass &);
        HSeparatorClass & operator=(const HSeparatorClass & );
        HSeparatorClass ();
      }; // class HSeparatorClass
      class VSeparatorClass
      {
      public:
        static GType type ()
        {
          return gtk_vseparator_get_type ();
        }
        static GType proxy_type ();

        static Inti::Object * get_wrapper (GObject * obj);

        static GObject * make_proxy ()
        {
          return (GObject*) g_type_create_instance (proxy_type ());
        }
        static GObjectClass * original_class ();
        static void class_init (GtkVSeparatorClass * klass);
      private:
        static GType type_;
        static GtkVSeparatorClass * original_class_;
        // This class can't be instantiated.
        friend class LookMrCompilerICanCallThesePrivateConstructors;
        VSeparatorClass (const VSeparatorClass &);
        VSeparatorClass & operator=(const VSeparatorClass & );
        VSeparatorClass ();
      }; // class VSeparatorClass
      
    }; //namespace Private

  }; // namespace Gtk

}; // namespace Inti

#endif // _INTI_GTK_SEPARATOR_CLASS_H_
